package maze.searchers;

public class ArrayStack<T> implements Stack<T> {
	@SuppressWarnings("unchecked")
	private T[] stuff = (T[])new Object[4];
	private int stored = 0;

	@Override
	public int size() {
		return stored;
	}

	@Override
	public T pop() {
		T result = top();
		stored -= 1;
		return result;
	}

	@SuppressWarnings("unchecked")
	@Override
	public void push(T data) {
		if (stored == stuff.length) {
			T[] oldstuff = stuff;
			stuff = (T[])new Object[stored * 2];
			for (int i = 0; i < stored; i++) {
				stuff[i] = oldstuff[i];
			}
		}
		
		stuff[stored] = data;
		stored += 1;
	}

	@Override
	public T top() {
		return stuff[stored - 1];
	}

	@Override
	public int capacity() {
		return stuff.length;
	}
}
