package maze.searchers;

import java.util.ArrayList;
import java.util.Comparator;

public class MinHeap<T> implements Searcher<T> {
	private ArrayList<T> heap;
	private Comparator<T> comparator;

	public MinHeap(Comparator<T> comparator) {
		heap = new ArrayList<>();
		this.comparator = comparator;
	}

	@Override
	public int size() {
		return heap.size();
	}

	@Override
	public int capacity() {
		return heap.size();
	}
	
	// Exists only for unit testing purposes.
	void backdoorAdd(T value) {
		heap.add(value);
	}
	
	// Exists only for unit testing purposes.
	T get(int i) {
		return heap.get(i);
	}
	
	/**
	 * Given an index, return the index of its parent.
	 */
	static int parent(int i) {
		// TODO Implement the correct calculation.
		return -1;
	}
	
	/**
	 * Given an index, return the index of its left child.
	 */
	static int left(int i) {
		// TODO Implement the correct calculation.
		return -1;
	}
	
	/**
	 * Given an index, return the index of its right child.
	 */
	static int right(int i) {
		// TODO Implement the correct calculation.
		return -1;
	}
	
	/**
	 * Given an index, return true if it is a legal array index, and false otherwise.
	 */
	boolean legal(int i) {
		// TODO Implement the correct calculation.
		return false;
	}

	/**
	 * Verify that each element is smaller than its children elements.
	 * Because of our use of an ArrayList to track the elements, we
	 * will always assume that the elements form a Heap that is as
	 * compact as possible.
	 * 
	 * Your solution can be simplified by using the legal(), left(), and right()
	 * methods.
	 */
	public boolean isHeap() {
		// TODO Implement the correct calculation.
		return false;
	}

	/**
	 * Return the root element, which will always be stored in
	 * the first position of the ArrayList.
	 */
	@Override
	public T peek() {
		// TODO Return the correct value.
		return null;
	}
	
	/**
	 * Swaps the values at indices i and j.
	 */
	void swap(int i, int j) {
		// TODO Implement swapping.
	}

	/**
	 * New elements are added to the end of the ArrayList, and then
	 * filtered up repeatedly when the element is found to be less
	 * than its parent. Use the Comparator object to calculate if an
	 * element is greater or less than another element. 
	 * 
	 * Your solution can be simplified by using the swap() and parent() methods.
	 */
	@Override
	public void add(T data) {
		// TODO implement add
	}
	
	/**
	 * Given the index of a parent, this method checks the value at that index
	 * against the values of its children. If either child is smaller than the 
	 * parent, the index of the smallest child is returned. If no children are 
	 * present, or the parent has the lowest value among the three, the parent's
	 * own index is returned.
	 * 
	 * Your solution can be simplified by using the legal(), left(),
	 * and right() methods.
	 */
	int indexOfLowestInFamily(int parent) {
		// TODO Implement solution
		return -1;
	}

	/**
	 * First, swap the first and last elements. Next, remove the last element,
	 * and save its value to be returned at the end of the method. This could
	 * cause a violation of the Heap property that all parents must
	 * be smaller than their children. If the element is less than
	 * only one of its children, swap these two elements. If the element
	 * is less than both of its children, swap the smaller of the two
	 * children with the element, so that we don't break the Heap
	 * property any further. Finally, when a swap was made, repeatedly
	 * check the subsequent descendants to guarantee that the Heap
	 * property is always preserved.
	 * 
	 * Your solution can be simplified by using the indexOfLowestInFamily()
	 * and swap() methods.
	 */
	@Override
	public T remove() {
		// TODO Implement remove().
		return null;
	}
}
